"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactBootstrapTypeahead = require("react-bootstrap-typeahead");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AsyncTypeaheadWidget = function (_React$Component) {
  _inherits(AsyncTypeaheadWidget, _React$Component);

  function AsyncTypeaheadWidget(props) {
    _classCallCheck(this, AsyncTypeaheadWidget);

    var _this = _possibleConstructorReturn(this, (AsyncTypeaheadWidget.__proto__ || Object.getPrototypeOf(AsyncTypeaheadWidget)).call(this, props));

    _this.state = {
      options: []
    };

    _this._renderMenuItemChildren = _this._renderMenuItemChildren.bind(_this);
    _this._handleSearch = _this._handleSearch.bind(_this);
    _this._handleSelectionChange = _this._handleSelectionChange.bind(_this);
    return _this;
  }

  _createClass(AsyncTypeaheadWidget, [{
    key: "render",
    value: function render() {
      return _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(_reactBootstrapTypeahead.AsyncTypeahead, {
          required: this.props.required,
          options: this.state.options,
          labelKey: "name",
          minLength: 3,
          onSearch: this._handleSearch,
          placeholder: "Search...",
          renderMenuItemChildren: this._renderMenuItemChildren,
          onChange: this._handleSelectionChange,
          ref: "typeahead"
        })
      );
    }
  }, {
    key: "_renderMenuItemChildren",
    value: function _renderMenuItemChildren(option, props, index) {
      return _react2.default.createElement(
        "div",
        { key: option.key },
        _react2.default.createElement(
          "span",
          null,
          option.name
        )
      );
    }
  }, {
    key: "_handleSearch",
    value: function _handleSearch(query) {
      var _this2 = this;

      if (!query) {
        return;
      }

      var authObj = {
        DoctorCompanyId: window.encounterTemplateV2User.DoctorCompanyId,
        Token: window.encounterTemplateV2User.AppLoginTokens[0].Token
      };

      var body = Object.assign(authObj, { Name: query });
      var asyncRequestObj = {
        method: "POST",
        headers: {
          RequestInfo: "TestUser#TestPass#" + authObj.DoctorCompanyId + "##" + authObj.Token,
          "Content-Type": "application/json"
        },
        body: JSON.stringify(body)
      };

      fetch(this.props.widgetData.queryURL, asyncRequestObj).then(function (resp) {
        return resp.json();
      }).then(function (json) {
        _this2.setState({ options: json.ItemList });
      });
    }
  }, {
    key: "_handleSelectionChange",
    value: function _handleSelectionChange(event) {
      if (!event) {
        return;
      }

      if (event.length > 0) {
        this.props.onChange(event);
      }

      this.refs.typeahead.getInstance().clear();
    }
  }]);

  return AsyncTypeaheadWidget;
}(_react2.default.Component);

exports.default = AsyncTypeaheadWidget;